diff --git a/gcc/m2/pge-boot/GDynamicStrings.cc b/gcc/m2/pge-boot/GDynamicStrings.cc
index 997802b3f84..32969692985 100644
--- a/gcc/m2/pge-boot/GDynamicStrings.cc
+++ b/gcc/m2/pge-boot/GDynamicStrings.cc
@@ -25,6 +25,8 @@ a copy of the GCC Runtime Library Exception along with this program;
 see the files COPYING3 and COPYING.RUNTIME respectively.  If not, see
 <http://www.gnu.org/licenses/>.  */
 
+#include "config.h"
+#include "system.h"
 #include <stdbool.h>
 #   if !defined (PROC_D)
 #      define PROC_D
@@ -40,19 +42,14 @@ see the files COPYING3 and COPYING.RUNTIME respectively.  If not, see
 #      define FALSE (1==0)
 #   endif
 
-#include <stddef.h>
-#include <string.h>
-#include <limits.h>
-#include <stdlib.h>
 #   include "GStorage.h"
-#include <unistd.h>
 #if defined(__cplusplus)
 #   undef NULL
 #   define NULL 0
 #endif
-#define _DynamicStrings_H
 #define _DynamicStrings_C
 
+#include "GDynamicStrings.h"
 #   include "Glibc.h"
 #   include "GStrLib.h"
 #   include "GStorage.h"
@@ -84,27 +81,27 @@ typedef struct DynamicStrings__T3_a DynamicStrings__T3;
 
 typedef enum {DynamicStrings_inuse, DynamicStrings_marked, DynamicStrings_onlist, DynamicStrings_poisoned} DynamicStrings_desState;
 
-typedef DynamicStrings_stringRecord *DynamicStrings_String;
+typedef DynamicStrings_stringRecord *DynamicStrings_String__opaque;
 
 struct DynamicStrings_DebugInfo_r {
-                                    DynamicStrings_String next;
-                                    void *file;
+                                    DynamicStrings_String__opaque next;
+                                    void * file;
                                     unsigned int line;
-                                    void *proc;
+                                    void * proc;
                                   };
 
 struct DynamicStrings_descriptor_r {
                                      bool charStarUsed;
-                                     void *charStar;
+                                     void * charStar;
                                      unsigned int charStarSize;
                                      bool charStarValid;
                                      DynamicStrings_desState state;
-                                     DynamicStrings_String garbage;
+                                     DynamicStrings_String__opaque garbage;
                                    };
 
 struct DynamicStrings_frameRec_r {
-                                   DynamicStrings_String alloc;
-                                   DynamicStrings_String dealloc;
+                                   DynamicStrings_String__opaque alloc;
+                                   DynamicStrings_String__opaque dealloc;
                                    DynamicStrings_frame next;
                                  };
 
@@ -112,7 +109,7 @@ struct DynamicStrings__T3_a { char array[(MaxBuf-1)+1]; };
 struct DynamicStrings_Contents_r {
                                    DynamicStrings__T3 buf;
                                    unsigned int len;
-                                   DynamicStrings_String next;
+                                   DynamicStrings_String__opaque next;
                                  };
 
 struct DynamicStrings_stringRecord_r {
@@ -123,7 +120,7 @@ struct DynamicStrings_stringRecord_r {
 
 static bool Initialized;
 static DynamicStrings_frame frameHead;
-static DynamicStrings_String captured;
+static DynamicStrings_String__opaque captured;
 
 /*
    InitString - creates and returns a String type object.
@@ -258,12 +255,25 @@ extern "C" int DynamicStrings_Index (DynamicStrings_String s, char ch, unsigned
 
 /*
    RIndex - returns the indice of the last occurance of, ch,
-            in String, s. The search starts at position, o.
-            -1 is returned if, ch, is not found.
+            in String, s.  The search starts at position, o.
+            -1 is returned if, ch, is not found.  The search
+            is performed left to right.
 */
 
 extern "C" int DynamicStrings_RIndex (DynamicStrings_String s, char ch, unsigned int o);
 
+/*
+   ReverseIndex - returns the indice of the last occurance of ch
+                  in String s.  The search starts at position o
+                  and searches from right to left.  The start position
+                  may be indexed negatively from the right (-1 is the
+                  last index).
+                  The return value if ch is found will always be positive.
+                  -1 is returned if ch is not found.
+*/
+
+extern "C" int DynamicStrings_ReverseIndex (DynamicStrings_String s, char ch, int o);
+
 /*
    RemoveComment - assuming that, comment, is a comment delimiter
                    which indicates anything to its right is a comment
@@ -390,7 +400,7 @@ extern "C" DynamicStrings_String DynamicStrings_PopAllocationExemption (bool hal
 /*
  writeStringDesc write out debugging information about string, s.  */
 
-static void writeStringDesc (DynamicStrings_String s);
+static void writeStringDesc (DynamicStrings_String__opaque s);
 
 /*
    writeNspace -
@@ -402,7 +412,7 @@ static void writeNspace (unsigned int n);
    DumpStringInfo -
 */
 
-static void DumpStringInfo (DynamicStrings_String s, unsigned int i);
+static void DumpStringInfo (DynamicStrings_String__opaque s, unsigned int i);
 
 /*
    DumpStringInfo -
@@ -420,7 +430,7 @@ static void doDSdbEnter (void);
    doDSdbExit -
 */
 
-static void doDSdbExit (DynamicStrings_String s);
+static void doDSdbExit (DynamicStrings_String__opaque s);
 
 /*
    DSdbEnter -
@@ -432,8 +442,8 @@ static void DSdbEnter (void);
    DSdbExit -
 */
 
-static void DSdbExit (DynamicStrings_String s);
-static unsigned int Capture (DynamicStrings_String s);
+static void DSdbExit (DynamicStrings_String__opaque s);
+static unsigned int Capture (DynamicStrings_String__opaque s);
 
 /*
    Min -
@@ -487,73 +497,73 @@ static void writeLn (void);
    AssignDebug - assigns, file, and, line, information to string, s.
 */
 
-static DynamicStrings_String AssignDebug (DynamicStrings_String s, const char *file_, unsigned int _file_high, unsigned int line, const char *proc_, unsigned int _proc_high);
+static DynamicStrings_String__opaque AssignDebug (DynamicStrings_String__opaque s, const char *file_, unsigned int _file_high, unsigned int line, const char *proc_, unsigned int _proc_high);
 
 /*
    IsOn - returns TRUE if, s, is on one of the debug lists.
 */
 
-static bool IsOn (DynamicStrings_String list, DynamicStrings_String s);
+static bool IsOn (DynamicStrings_String__opaque list, DynamicStrings_String__opaque s);
 
 /*
    AddTo - adds string, s, to, list.
 */
 
-static void AddTo (DynamicStrings_String *list, DynamicStrings_String s);
+static void AddTo (DynamicStrings_String__opaque *list, DynamicStrings_String__opaque s);
 
 /*
    SubFrom - removes string, s, from, list.
 */
 
-static void SubFrom (DynamicStrings_String *list, DynamicStrings_String s);
+static void SubFrom (DynamicStrings_String__opaque *list, DynamicStrings_String__opaque s);
 
 /*
    AddAllocated - adds string, s, to the head of the allocated list.
 */
 
-static void AddAllocated (DynamicStrings_String s);
+static void AddAllocated (DynamicStrings_String__opaque s);
 
 /*
    AddDeallocated - adds string, s, to the head of the deallocated list.
 */
 
-static void AddDeallocated (DynamicStrings_String s);
+static void AddDeallocated (DynamicStrings_String__opaque s);
 
 /*
    IsOnAllocated - returns TRUE if the string, s, has ever been allocated.
 */
 
-static bool IsOnAllocated (DynamicStrings_String s);
+static bool IsOnAllocated (DynamicStrings_String__opaque s);
 
 /*
    IsOnDeallocated - returns TRUE if the string, s, has ever been deallocated.
 */
 
-static bool IsOnDeallocated (DynamicStrings_String s);
+static bool IsOnDeallocated (DynamicStrings_String__opaque s);
 
 /*
    SubAllocated - removes string, s, from the list of allocated strings.
 */
 
-static void SubAllocated (DynamicStrings_String s);
+static void SubAllocated (DynamicStrings_String__opaque s);
 
 /*
    SubDeallocated - removes string, s, from the list of deallocated strings.
 */
 
-static void SubDeallocated (DynamicStrings_String s);
+static void SubDeallocated (DynamicStrings_String__opaque s);
 
 /*
    SubDebugInfo - removes string, s, from the list of allocated strings.
 */
 
-static void SubDebugInfo (DynamicStrings_String s);
+static void SubDebugInfo (DynamicStrings_String__opaque s);
 
 /*
    AddDebugInfo - adds string, s, to the list of allocated strings.
 */
 
-static void AddDebugInfo (DynamicStrings_String s);
+static void AddDebugInfo (DynamicStrings_String__opaque s);
 
 /*
    ConcatContents - add the contents of string, a, where, h, is the
@@ -566,19 +576,19 @@ static void ConcatContents (DynamicStrings_Contents *c, const char *a_, unsigned
    DeallocateCharStar - deallocates any charStar.
 */
 
-static void DeallocateCharStar (DynamicStrings_String s);
+static void DeallocateCharStar (DynamicStrings_String__opaque s);
 
 /*
    CheckPoisoned - checks for a poisoned string, s.
 */
 
-static DynamicStrings_String CheckPoisoned (DynamicStrings_String s);
+static DynamicStrings_String__opaque CheckPoisoned (DynamicStrings_String__opaque s);
 
 /*
    MarkInvalid - marks the char * version of String, s, as invalid.
 */
 
-static void MarkInvalid (DynamicStrings_String s);
+static void MarkInvalid (DynamicStrings_String__opaque s);
 
 /*
    ConcatContentsAddress - concatenate the string, a, where, h, is the
@@ -593,13 +603,13 @@ static void ConcatContentsAddress (DynamicStrings_Contents *c, void * a, unsigne
                   onlist.  String, a, is returned.
 */
 
-static DynamicStrings_String AddToGarbage (DynamicStrings_String a, DynamicStrings_String b);
+static DynamicStrings_String__opaque AddToGarbage (DynamicStrings_String__opaque a, DynamicStrings_String__opaque b);
 
 /*
    IsOnGarbage - returns TRUE if, s, is on string, e, garbage list.
 */
 
-static bool IsOnGarbage (DynamicStrings_String e, DynamicStrings_String s);
+static bool IsOnGarbage (DynamicStrings_String__opaque e, DynamicStrings_String__opaque s);
 
 /*
    IsWhite - returns TRUE if, ch, is a space or a tab.
@@ -611,19 +621,19 @@ static bool IsWhite (char ch);
    DumpState -
 */
 
-static void DumpState (DynamicStrings_String s);
+static void DumpState (DynamicStrings_String__opaque s);
 
 /*
    DumpStringSynopsis -
 */
 
-static void DumpStringSynopsis (DynamicStrings_String s);
+static void DumpStringSynopsis (DynamicStrings_String__opaque s);
 
 /*
    DumpString - displays the contents of string, s.
 */
 
-static void DumpString (DynamicStrings_String s);
+static void DumpString (DynamicStrings_String__opaque s);
 
 /*
    Init - initialize the module.
@@ -635,7 +645,7 @@ static void Init (void);
 /*
  writeStringDesc write out debugging information about string, s.  */
 
-static void writeStringDesc (DynamicStrings_String s)
+static void writeStringDesc (DynamicStrings_String__opaque s)
 {
   writeCstring (s->debug.file);
   writeString ((const char *) ":", 1);
@@ -691,7 +701,7 @@ static void writeNspace (unsigned int n)
    DumpStringInfo -
 */
 
-static void DumpStringInfo (DynamicStrings_String s, unsigned int i)
+static void DumpStringInfo (DynamicStrings_String__opaque s, unsigned int i)
 {
   if (s != NULL)
     {
@@ -739,11 +749,11 @@ static void doDSdbEnter (void)
    doDSdbExit -
 */
 
-static void doDSdbExit (DynamicStrings_String s)
+static void doDSdbExit (DynamicStrings_String__opaque s)
 {
   if (CheckOn)
     {
-      s = DynamicStrings_PopAllocationExemption (true, s);
+      s = static_cast<DynamicStrings_String__opaque> (DynamicStrings_PopAllocationExemption (true, static_cast<DynamicStrings_String> (s)));
     }
 }
 
@@ -761,11 +771,11 @@ static void DSdbEnter (void)
    DSdbExit -
 */
 
-static void DSdbExit (DynamicStrings_String s)
+static void DSdbExit (DynamicStrings_String__opaque s)
 {
 }
 
-static unsigned int Capture (DynamicStrings_String s)
+static unsigned int Capture (DynamicStrings_String__opaque s)
 {
   /* 
  *   #undef GM2_DEBUG_DYNAMICSTINGS
@@ -833,7 +843,7 @@ static void writeString (const char *a_, unsigned int _a_high)
   /* make a local copy of each unbounded array.  */
   memcpy (a, a_, _a_high+1);
 
-  i = static_cast<int> (libc_write (1, &a, static_cast<size_t> (StrLib_StrLen ((const char *) a, _a_high))));
+  i = static_cast<int> (libc_write (1, const_cast<void*> (static_cast<const void*>(a)), static_cast<size_t> (StrLib_StrLen ((const char *) a, _a_high))));
 }
 
 
@@ -941,7 +951,7 @@ static void writeLn (void)
    AssignDebug - assigns, file, and, line, information to string, s.
 */
 
-static DynamicStrings_String AssignDebug (DynamicStrings_String s, const char *file_, unsigned int _file_high, unsigned int line, const char *proc_, unsigned int _proc_high)
+static DynamicStrings_String__opaque AssignDebug (DynamicStrings_String__opaque s, const char *file_, unsigned int _file_high, unsigned int line, const char *proc_, unsigned int _proc_high)
 {
   void * f;
   void * p;
@@ -952,8 +962,8 @@ static DynamicStrings_String AssignDebug (DynamicStrings_String s, const char *f
   memcpy (file, file_, _file_high+1);
   memcpy (proc, proc_, _proc_high+1);
 
-  f = &file;
-  p = &proc;
+  f = const_cast<void*> (static_cast<const void*>(file));
+  p = const_cast<void*> (static_cast<const void*>(proc));
   Storage_ALLOCATE (&s->debug.file, (StrLib_StrLen ((const char *) file, _file_high))+1);
   if ((libc_strncpy (s->debug.file, f, (StrLib_StrLen ((const char *) file, _file_high))+1)) == NULL)
     {}  /* empty.  */
@@ -971,7 +981,7 @@ static DynamicStrings_String AssignDebug (DynamicStrings_String s, const char *f
    IsOn - returns TRUE if, s, is on one of the debug lists.
 */
 
-static bool IsOn (DynamicStrings_String list, DynamicStrings_String s)
+static bool IsOn (DynamicStrings_String__opaque list, DynamicStrings_String__opaque s)
 {
   while ((list != s) && (list != NULL))
     {
@@ -987,12 +997,12 @@ static bool IsOn (DynamicStrings_String list, DynamicStrings_String s)
    AddTo - adds string, s, to, list.
 */
 
-static void AddTo (DynamicStrings_String *list, DynamicStrings_String s)
+static void AddTo (DynamicStrings_String__opaque *list, DynamicStrings_String__opaque s)
 {
   if ((*list) == NULL)
     {
       (*list) = s;
-      s->debug.next = NULL;
+      s->debug.next = static_cast<DynamicStrings_String__opaque> (NULL);
     }
   else
     {
@@ -1006,9 +1016,9 @@ static void AddTo (DynamicStrings_String *list, DynamicStrings_String s)
    SubFrom - removes string, s, from, list.
 */
 
-static void SubFrom (DynamicStrings_String *list, DynamicStrings_String s)
+static void SubFrom (DynamicStrings_String__opaque *list, DynamicStrings_String__opaque s)
 {
-  DynamicStrings_String p;
+  DynamicStrings_String__opaque p;
 
   if ((*list) == s)
     {
@@ -1028,10 +1038,10 @@ static void SubFrom (DynamicStrings_String *list, DynamicStrings_String s)
       else
         {
           /* not found, quit  */
-          return ;
+          return;
         }
     }
-  s->debug.next = NULL;
+  s->debug.next = static_cast<DynamicStrings_String__opaque> (NULL);
 }
 
 
@@ -1039,7 +1049,7 @@ static void SubFrom (DynamicStrings_String *list, DynamicStrings_String s)
    AddAllocated - adds string, s, to the head of the allocated list.
 */
 
-static void AddAllocated (DynamicStrings_String s)
+static void AddAllocated (DynamicStrings_String__opaque s)
 {
   Init ();
   AddTo (&frameHead->alloc, s);
@@ -1050,7 +1060,7 @@ static void AddAllocated (DynamicStrings_String s)
    AddDeallocated - adds string, s, to the head of the deallocated list.
 */
 
-static void AddDeallocated (DynamicStrings_String s)
+static void AddDeallocated (DynamicStrings_String__opaque s)
 {
   Init ();
   AddTo (&frameHead->dealloc, s);
@@ -1061,7 +1071,7 @@ static void AddDeallocated (DynamicStrings_String s)
    IsOnAllocated - returns TRUE if the string, s, has ever been allocated.
 */
 
-static bool IsOnAllocated (DynamicStrings_String s)
+static bool IsOnAllocated (DynamicStrings_String__opaque s)
 {
   DynamicStrings_frame f;
 
@@ -1087,7 +1097,7 @@ static bool IsOnAllocated (DynamicStrings_String s)
    IsOnDeallocated - returns TRUE if the string, s, has ever been deallocated.
 */
 
-static bool IsOnDeallocated (DynamicStrings_String s)
+static bool IsOnDeallocated (DynamicStrings_String__opaque s)
 {
   DynamicStrings_frame f;
 
@@ -1113,7 +1123,7 @@ static bool IsOnDeallocated (DynamicStrings_String s)
    SubAllocated - removes string, s, from the list of allocated strings.
 */
 
-static void SubAllocated (DynamicStrings_String s)
+static void SubAllocated (DynamicStrings_String__opaque s)
 {
   DynamicStrings_frame f;
 
@@ -1123,7 +1133,7 @@ static void SubAllocated (DynamicStrings_String s)
     if (IsOn (f->alloc, s))
       {
         SubFrom (&f->alloc, s);
-        return ;
+        return;
       }
     else
       {
@@ -1137,7 +1147,7 @@ static void SubAllocated (DynamicStrings_String s)
    SubDeallocated - removes string, s, from the list of deallocated strings.
 */
 
-static void SubDeallocated (DynamicStrings_String s)
+static void SubDeallocated (DynamicStrings_String__opaque s)
 {
   DynamicStrings_frame f;
 
@@ -1147,7 +1157,7 @@ static void SubDeallocated (DynamicStrings_String s)
     if (IsOn (f->dealloc, s))
       {
         SubFrom (&f->dealloc, s);
-        return ;
+        return;
       }
     else
       {
@@ -1161,13 +1171,13 @@ static void SubDeallocated (DynamicStrings_String s)
    SubDebugInfo - removes string, s, from the list of allocated strings.
 */
 
-static void SubDebugInfo (DynamicStrings_String s)
+static void SubDebugInfo (DynamicStrings_String__opaque s)
 {
   if (IsOnDeallocated (s))
     {
       Assertion_Assert (! DebugOn);
       /* string has already been deallocated  */
-      return ;
+      return;
     }
   if (IsOnAllocated (s))
     {
@@ -1186,9 +1196,9 @@ static void SubDebugInfo (DynamicStrings_String s)
    AddDebugInfo - adds string, s, to the list of allocated strings.
 */
 
-static void AddDebugInfo (DynamicStrings_String s)
+static void AddDebugInfo (DynamicStrings_String__opaque s)
 {
-  s->debug.next = NULL;
+  s->debug.next = static_cast<DynamicStrings_String__opaque> (NULL);
   s->debug.file = NULL;
   s->debug.line = 0;
   s->debug.proc = NULL;
@@ -1225,7 +1235,7 @@ static void ConcatContents (DynamicStrings_Contents *c, const char *a_, unsigned
       Storage_ALLOCATE ((void **) &(*c).next, sizeof (DynamicStrings_stringRecord));
       (*c).next->head = NULL;
       (*c).next->contents.len = 0;
-      (*c).next->contents.next = NULL;
+      (*c).next->contents.next = static_cast<DynamicStrings_String__opaque> (NULL);
       ConcatContents (&(*c).next->contents, (const char *) a, _a_high, h, o);
       AddDebugInfo ((*c).next);
       (*c).next = AssignDebug ((*c).next, (const char *) "../../gcc/m2/gm2-libs/DynamicStrings.mod", 40, 722, (const char *) "ConcatContents", 14);
@@ -1241,7 +1251,7 @@ static void ConcatContents (DynamicStrings_Contents *c, const char *a_, unsigned
    DeallocateCharStar - deallocates any charStar.
 */
 
-static void DeallocateCharStar (DynamicStrings_String s)
+static void DeallocateCharStar (DynamicStrings_String__opaque s)
 {
   if ((s != NULL) && (s->head != NULL))
     {
@@ -1261,7 +1271,7 @@ static void DeallocateCharStar (DynamicStrings_String s)
    CheckPoisoned - checks for a poisoned string, s.
 */
 
-static DynamicStrings_String CheckPoisoned (DynamicStrings_String s)
+static DynamicStrings_String__opaque CheckPoisoned (DynamicStrings_String__opaque s)
 {
   if (((PoisonOn && (s != NULL)) && (s->head != NULL)) && (s->head->state == DynamicStrings_poisoned))
     {
@@ -1278,7 +1288,7 @@ static DynamicStrings_String CheckPoisoned (DynamicStrings_String s)
    MarkInvalid - marks the char * version of String, s, as invalid.
 */
 
-static void MarkInvalid (DynamicStrings_String s)
+static void MarkInvalid (DynamicStrings_String__opaque s)
 {
   if (PoisonOn)
     {
@@ -1321,7 +1331,7 @@ static void ConcatContentsAddress (DynamicStrings_Contents *c, void * a, unsigne
       Storage_ALLOCATE ((void **) &(*c).next, sizeof (DynamicStrings_stringRecord));
       (*c).next->head = NULL;
       (*c).next->contents.len = 0;
-      (*c).next->contents.next = NULL;
+      (*c).next->contents.next = static_cast<DynamicStrings_String__opaque> (NULL);
       ConcatContentsAddress (&(*c).next->contents, reinterpret_cast<void *> (p), h-j);
       AddDebugInfo ((*c).next);
       if (TraceOn)
@@ -1332,7 +1342,7 @@ static void ConcatContentsAddress (DynamicStrings_Contents *c, void * a, unsigne
   else
     {
       (*c).len = i;
-      (*c).next = NULL;
+      (*c).next = static_cast<DynamicStrings_String__opaque> (NULL);
     }
 }
 
@@ -1343,9 +1353,9 @@ static void ConcatContentsAddress (DynamicStrings_Contents *c, void * a, unsigne
                   onlist.  String, a, is returned.
 */
 
-static DynamicStrings_String AddToGarbage (DynamicStrings_String a, DynamicStrings_String b)
+static DynamicStrings_String__opaque AddToGarbage (DynamicStrings_String__opaque a, DynamicStrings_String__opaque b)
 {
-  DynamicStrings_String c;
+  DynamicStrings_String__opaque c;
 
   if (PoisonOn)
     {
@@ -1382,7 +1392,7 @@ static DynamicStrings_String AddToGarbage (DynamicStrings_String a, DynamicStrin
    IsOnGarbage - returns TRUE if, s, is on string, e, garbage list.
 */
 
-static bool IsOnGarbage (DynamicStrings_String e, DynamicStrings_String s)
+static bool IsOnGarbage (DynamicStrings_String__opaque e, DynamicStrings_String__opaque s)
 {
   if ((e != NULL) && (s != NULL))
     {
@@ -1420,7 +1430,7 @@ static bool IsWhite (char ch)
    DumpState -
 */
 
-static void DumpState (DynamicStrings_String s)
+static void DumpState (DynamicStrings_String__opaque s)
 {
   switch (s->head->state)
     {
@@ -1454,7 +1464,7 @@ static void DumpState (DynamicStrings_String s)
    DumpStringSynopsis -
 */
 
-static void DumpStringSynopsis (DynamicStrings_String s)
+static void DumpStringSynopsis (DynamicStrings_String__opaque s)
 {
   writeCstring (s->debug.file);
   writeString ((const char *) ":", 1);
@@ -1487,9 +1497,9 @@ static void DumpStringSynopsis (DynamicStrings_String s)
    DumpString - displays the contents of string, s.
 */
 
-static void DumpString (DynamicStrings_String s)
+static void DumpString (DynamicStrings_String__opaque s)
 {
-  DynamicStrings_String t;
+  DynamicStrings_String__opaque t;
 
   if (s != NULL)
     {
@@ -1531,7 +1541,7 @@ static void Init (void)
 
 extern "C" DynamicStrings_String DynamicStrings_InitString (const char *a_, unsigned int _a_high)
 {
-  DynamicStrings_String s;
+  DynamicStrings_String__opaque s;
   char a[_a_high+1];
 
   /* make a local copy of each unbounded array.  */
@@ -1539,21 +1549,21 @@ extern "C" DynamicStrings_String DynamicStrings_InitString (const char *a_, unsi
 
   Storage_ALLOCATE ((void **) &s, sizeof (DynamicStrings_stringRecord));
   s->contents.len = 0;
-  s->contents.next = NULL;
+  s->contents.next = static_cast<DynamicStrings_String__opaque> (NULL);
   ConcatContents (&s->contents, (const char *) a, _a_high, StrLib_StrLen ((const char *) a, _a_high), 0);
   Storage_ALLOCATE ((void **) &s->head, sizeof (DynamicStrings_descriptor));
   s->head->charStarUsed = false;
   s->head->charStar = NULL;
   s->head->charStarSize = 0;
   s->head->charStarValid = false;
-  s->head->garbage = NULL;
+  s->head->garbage = static_cast<DynamicStrings_String__opaque> (NULL);
   s->head->state = DynamicStrings_inuse;
   AddDebugInfo (s);
   if (TraceOn)
     {
       s = AssignDebug (s, (const char *) "../../gcc/m2/gm2-libs/DynamicStrings.mod", 40, 758, (const char *) "InitString", 10);
     }
-  return s;
+  return static_cast<DynamicStrings_String> (s);
   /* static analysis guarentees a RETURN statement will be used before here.  */
   __builtin_unreachable ();
 }
@@ -1566,48 +1576,48 @@ extern "C" DynamicStrings_String DynamicStrings_InitString (const char *a_, unsi
 
 extern "C" DynamicStrings_String DynamicStrings_KillString (DynamicStrings_String s)
 {
-  DynamicStrings_String t;
+  DynamicStrings_String__opaque t;
 
   if (PoisonOn)
     {
-      s = CheckPoisoned (s);
+      s = static_cast<DynamicStrings_String> (CheckPoisoned (static_cast<DynamicStrings_String__opaque> (s)));
     }
   if (s != NULL)
     {
       if (CheckOn)
         {
           /* avoid gcc warning by using compound statement even if not strictly necessary.  */
-          if (IsOnAllocated (s))
+          if (IsOnAllocated (static_cast<DynamicStrings_String__opaque> (s)))
             {
-              SubAllocated (s);
+              SubAllocated (static_cast<DynamicStrings_String__opaque> (s));
             }
-          else if (IsOnDeallocated (s))
+          else if (IsOnDeallocated (static_cast<DynamicStrings_String__opaque> (s)))
             {
               /* avoid dangling else.  */
-              SubDeallocated (s);
+              SubDeallocated (static_cast<DynamicStrings_String__opaque> (s));
             }
         }
-      if (s->head != NULL)
+      if (static_cast<DynamicStrings_String__opaque> (s)->head != NULL)
         {
-          s->head->state = DynamicStrings_poisoned;
-          s->head->garbage = DynamicStrings_KillString (s->head->garbage);
+          static_cast<DynamicStrings_String__opaque> (s)->head->state = DynamicStrings_poisoned;
+          static_cast<DynamicStrings_String__opaque> (s)->head->garbage = static_cast<DynamicStrings_String__opaque> (DynamicStrings_KillString (static_cast<DynamicStrings_String> (static_cast<DynamicStrings_String__opaque> (s)->head->garbage)));
           if (! PoisonOn)
             {
-              DeallocateCharStar (s);
+              DeallocateCharStar (static_cast<DynamicStrings_String__opaque> (s));
             }
           if (! PoisonOn)
             {
-              Storage_DEALLOCATE ((void **) &s->head, sizeof (DynamicStrings_descriptor));
-              s->head = NULL;
+              Storage_DEALLOCATE ((void **) &static_cast<DynamicStrings_String__opaque> (s)->head, sizeof (DynamicStrings_descriptor));
+              static_cast<DynamicStrings_String__opaque> (s)->head = NULL;
             }
         }
-      t = DynamicStrings_KillString (s->contents.next);
+      t = static_cast<DynamicStrings_String__opaque> (DynamicStrings_KillString (static_cast<DynamicStrings_String> (static_cast<DynamicStrings_String__opaque> (s)->contents.next)));
       if (! PoisonOn)
         {
           Storage_DEALLOCATE ((void **) &s, sizeof (DynamicStrings_stringRecord));
         }
     }
-  return NULL;
+  return static_cast<DynamicStrings_String> (NULL);
   /* static analysis guarentees a RETURN statement will be used before here.  */
   __builtin_unreachable ();
 }
@@ -1635,11 +1645,11 @@ extern "C" void DynamicStrings_Fin (DynamicStrings_String s)
 
 extern "C" DynamicStrings_String DynamicStrings_InitStringCharStar (void * a)
 {
-  DynamicStrings_String s;
+  DynamicStrings_String__opaque s;
 
   Storage_ALLOCATE ((void **) &s, sizeof (DynamicStrings_stringRecord));
   s->contents.len = 0;
-  s->contents.next = NULL;
+  s->contents.next = static_cast<DynamicStrings_String__opaque> (NULL);
   if (a != NULL)
     {
       ConcatContentsAddress (&s->contents, a, static_cast<unsigned int> (libc_strlen (a)));
@@ -1649,14 +1659,14 @@ extern "C" DynamicStrings_String DynamicStrings_InitStringCharStar (void * a)
   s->head->charStar = NULL;
   s->head->charStarSize = 0;
   s->head->charStarValid = false;
-  s->head->garbage = NULL;
+  s->head->garbage = static_cast<DynamicStrings_String__opaque> (NULL);
   s->head->state = DynamicStrings_inuse;
   AddDebugInfo (s);
   if (TraceOn)
     {
       s = AssignDebug (s, (const char *) "../../gcc/m2/gm2-libs/DynamicStrings.mod", 40, 957, (const char *) "InitStringCharStar", 18);
     }
-  return s;
+  return static_cast<DynamicStrings_String> (s);
   /* static analysis guarentees a RETURN statement will be used before here.  */
   __builtin_unreachable ();
 }
@@ -1672,16 +1682,16 @@ extern "C" DynamicStrings_String DynamicStrings_InitStringChar (char ch)
 
   struct InitStringChar__T5_a { char array[1+1]; };
   InitStringChar__T5 a;
-  DynamicStrings_String s;
+  DynamicStrings_String__opaque s;
 
   a.array[0] = ch;
   a.array[1] = ASCII_nul;
-  s = DynamicStrings_InitString ((const char *) &a.array[0], 1);
+  s = static_cast<DynamicStrings_String__opaque> (DynamicStrings_InitString ((const char *) &a.array[0], 1));
   if (TraceOn)
     {
       s = AssignDebug (s, (const char *) "../../gcc/m2/gm2-libs/DynamicStrings.mod", 40, 977, (const char *) "InitStringChar", 14);
     }
-  return s;
+  return static_cast<DynamicStrings_String> (s);
   /* static analysis guarentees a RETURN statement will be used before here.  */
   __builtin_unreachable ();
 }
@@ -1695,11 +1705,11 @@ extern "C" DynamicStrings_String DynamicStrings_Mark (DynamicStrings_String s)
 {
   if (PoisonOn)
     {
-      s = CheckPoisoned (s);
+      s = static_cast<DynamicStrings_String> (CheckPoisoned (static_cast<DynamicStrings_String__opaque> (s)));
     }
-  if ((s != NULL) && (s->head->state == DynamicStrings_inuse))
+  if ((s != NULL) && (static_cast<DynamicStrings_String__opaque> (s)->head->state == DynamicStrings_inuse))
     {
-      s->head->state = DynamicStrings_marked;
+      static_cast<DynamicStrings_String__opaque> (s)->head->state = DynamicStrings_marked;
     }
   return s;
   /* static analysis guarentees a RETURN statement will be used before here.  */
@@ -1719,7 +1729,7 @@ extern "C" unsigned int DynamicStrings_Length (DynamicStrings_String s)
     }
   else
     {
-      return s->contents.len+(DynamicStrings_Length (s->contents.next));
+      return static_cast<DynamicStrings_String__opaque> (s)->contents.len+(DynamicStrings_Length (static_cast<DynamicStrings_String> (static_cast<DynamicStrings_String__opaque> (s)->contents.next)));
     }
   /* static analysis guarentees a RETURN statement will be used before here.  */
   __builtin_unreachable ();
@@ -1732,12 +1742,12 @@ extern "C" unsigned int DynamicStrings_Length (DynamicStrings_String s)
 
 extern "C" DynamicStrings_String DynamicStrings_ConCat (DynamicStrings_String a, DynamicStrings_String b)
 {
-  DynamicStrings_String t;
+  DynamicStrings_String__opaque t;
 
   if (PoisonOn)
     {
-      a = CheckPoisoned (a);
-      b = CheckPoisoned (b);
+      a = static_cast<DynamicStrings_String> (CheckPoisoned (static_cast<DynamicStrings_String__opaque> (a)));
+      b = static_cast<DynamicStrings_String> (CheckPoisoned (static_cast<DynamicStrings_String__opaque> (b)));
     }
   if (a == b)
     {
@@ -1746,17 +1756,17 @@ extern "C" DynamicStrings_String DynamicStrings_ConCat (DynamicStrings_String a,
   else if (a != NULL)
     {
       /* avoid dangling else.  */
-      a = AddToGarbage (a, b);
-      MarkInvalid (a);
-      t = a;
+      a = static_cast<DynamicStrings_String> (AddToGarbage (static_cast<DynamicStrings_String__opaque> (a), static_cast<DynamicStrings_String__opaque> (b)));
+      MarkInvalid (static_cast<DynamicStrings_String__opaque> (a));
+      t = static_cast<DynamicStrings_String__opaque> (a);
       while (b != NULL)
         {
           while ((t->contents.len == MaxBuf) && (t->contents.next != NULL))
             {
               t = t->contents.next;
             }
-          ConcatContents (&t->contents, (const char *) &b->contents.buf.array[0], (MaxBuf-1), b->contents.len, 0);
-          b = b->contents.next;
+          ConcatContents (&t->contents, (const char *) &static_cast<DynamicStrings_String__opaque> (b)->contents.buf.array[0], (MaxBuf-1), static_cast<DynamicStrings_String__opaque> (b)->contents.len, 0);
+          b = static_cast<DynamicStrings_String> (static_cast<DynamicStrings_String__opaque> (b)->contents.next);
         }
     }
   if ((a == NULL) && (b != NULL))
